; include file for the Free-DOS(98) XMS driver
; Copyright 2001, Martin Stroemberg.
; Copyright (c) 1995, Till Gerken

%define DRIVER_VERSION		'0.9.Sand'
DRIVER_VER			equ	0200h | 9
INTERFACE_VER			equ	0200h

XMS_START			equ	1088	; XMS starts at 1088k after HMA

CMD_INIT			equ	0	; init command (used when installed)

STATUS_OK			equ	0100h	; driver is initialized and ok
STATUS_BAD			equ	8000h	; driver couldn't be installed

XMS_NOT_IMPLEMENTED		equ	80h
XMS_VDISK_DETECTED		equ	81h
XMS_A20_FAILURE			equ	82h
XMS_DRIVER_FAILURE		equ	8eh
XMS_DRIVER_FATAL		equ	8fh
XMS_HMA_NOT_THERE		equ	90h
XMS_HMA_IN_USE			equ	91h
XMS_HMAREQ_TOO_SMALL		equ	92h
XMS_HMA_NOT_USED		equ	93h
XMS_A20_STILL_ENABLED		equ	94h
XMS_ALREADY_ALLOCATED		equ	0a0h
XMS_NO_HANDLE_LEFT		equ	0a1h
XMS_INVALID_HANDLE		equ	0a2h
XMS_INVALID_SOURCE_HANDLE	equ	0a3h
XMS_INVALID_SOURCE_OFFSET	equ	0a4h
XMS_INVALID_DESTINATION_HANDLE	equ	0a5h
XMS_INVALID_DESTINATION_OFFSET	equ	0a6h
XMS_INVALID_LENGTH		equ	0a7h
XMS_OVERLAP			equ	0a8h
XMS_PARITY_ERROR		equ	0a9h
XMS_BLOCK_NOT_LOCKED		equ	0aah
XMS_BLOCK_LOCKED		equ	0abh
XMS_LOCK_COUNT_OVERFLOW		equ	0ach
XMS_LOCK_FAILED			equ	0adh
XMS_ONLY_SMALLER_UMB		equ	0b0h
XMS_NO_UMB_AVAILABLE		equ	0b1h
XMS_UMB_SEGMENT_NR_INVALID	equ	0b2h

XMS_COMMAND_LINE_LENGTH_MAX	equ	100h

FLAG_INITIALISED 		equ 	1
FLAG_USE_BIOS 			equ 	2
FLAG_CPU286 			equ 	4

struc	request_hdr
  .req_size	resb	1		; number of bytes stored
  .unit_id	resb	1		; unit ID code
  .cmd		resb	1		; command code
  .status	resw	1		; status word
  .rsvd		resb	8		; reserved
endstruc

struc	init_strc
  .init_hdr	resb	request_hdr_size
  .units	resb	1		; number of supported units
  .end_addr	resd	1		; end address of resident part
  .cmd_line	resd	1		; address of command line
endstruc

struc	xms_move_strc
  .len		resd	1		; block length in bytes
  .src_handle	resw	1		; source handle
  .src_offset	resd	1		; offset into source
  .dest_handle	resw	1		; destination handle
  .dest_offset	resd	1		; offset into destination
endstruc

struc	xms_handle
  .xbase	resw	1		; base address in kbytes
  .xsize	resw	1		; size in kbytes
  .used		resb	1		; 1 if used, > 1 if locked.
endstruc

struc	desc_cache286
  .base_low	resw	1
  .base_high	resb	1
  .access	resb	1
  .limit	resw	1
endstruc

struc	loadall286_tbl
		resw	2
  .msw		resw	1
		resw	8
  .tr_reg	resw	1
  .flags	resw	1
  .ip		resw	1
  .ldt_reg	resw	1
  .ds_reg	resw	1
  .ss_reg	resw	1
  .cs_reg	resw	1
  .es_reg	resw	1
  .di		resw	1
  .si		resw	1
  .bp		resw	1
  .sp		resw	1
  .bx		resw	1
  .dx		resw	1
  .cx		resw	1
  .ax		resw	1
  .es_desc	resb	desc_cache286_size
  .cs_desc	resb	desc_cache286_size
  .ss_desc	resb	desc_cache286_size
  .ds_desc	resb	desc_cache286_size
  .gdt_desc	resb	desc_cache286_size
  .ldt_desc	resb	desc_cache286_size
  .idt_desc	resb	desc_cache286_size
  .tss_desc	resb	desc_cache286_size
endstruc

